=== doc/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2025, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

################################################################################
#
#       INSTALLS
#
################################################################################

install(FILES yadifa.conf.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5 RENAME yadifa.conf.5 COMPONENT man)
install(FILES yadifa.rc.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5 RENAME yadifa.rc.5 COMPONENT man)
install(FILES yadifad.conf.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5 RENAME yadifad.conf.5 COMPONENT man)
install(FILES yakeyrolld.conf.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5 RENAME yakeyrolld.conf.5 COMPONENT man)

install(FILES yadifad.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME yadifad.8 COMPONENT man)
install(FILES yadifa.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME yadifa.8 COMPONENT man)
install(FILES yakeyrolld.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME yakeyrolld.8 COMPONENT man)
