=== lib/dnscore/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2025, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)
include(${CMAKE_SOURCE_DIR}/cmake/EURidToolbox.cmake)

project(dnscore LANGUAGES C)
set(CMAKE_C_STANDARD 11)
set(LIBRARY_SO_VERSION                       10.0.0)
set(LIBRARY_SO_MAJOR                             10)

set(PACKAGE "dnscore")

kvstatus("building" "${PACKAGE}")

add_definitions(-DDNSCORE_BUILD)

################################################################################
#
#       SOURCES
#
################################################################################

set(LIBRARY_SOURCE_PATH "src")
set(LIBRARY_HEADER_PATH "include/dnscore")
set(LIBRARY_CONFIG_FILE "dnscore_config.h")
set(LIBRARY_FEATURES_FILE "dnscore_config_features.h")
set(LIBRARY_FEATURES_PREFIX "DNSCORE_")

set(LIBRARY_SOURCES
    ${LIBRARY_SOURCE_PATH}/acl.c
    ${LIBRARY_SOURCE_PATH}/acl_config.c
    ${LIBRARY_SOURCE_PATH}/alarm.c
    #${LIBRARY_SOURCE_PATH}/allocator.c
    ${LIBRARY_SOURCE_PATH}/async.c
    ${LIBRARY_SOURCE_PATH}/base16.c
    ${LIBRARY_SOURCE_PATH}/base32.c
    ${LIBRARY_SOURCE_PATH}/base32hex.c
    ${LIBRARY_SOURCE_PATH}/base64.c
    ${LIBRARY_SOURCE_PATH}/basic_priority_queue.c
    ${LIBRARY_SOURCE_PATH}/buffer_input_stream.c
    ${LIBRARY_SOURCE_PATH}/buffer_output_stream.c
    ${LIBRARY_SOURCE_PATH}/buffered_file.c
    ${LIBRARY_SOURCE_PATH}/bytearray_input_stream.c
    ${LIBRARY_SOURCE_PATH}/bytearray_output_stream.c
    ${LIBRARY_SOURCE_PATH}/bytezarray_output_stream.c
    ${LIBRARY_SOURCE_PATH}/cache.c
    ${LIBRARY_SOURCE_PATH}/checked_output_stream.c
    ${LIBRARY_SOURCE_PATH}/circular_file.c
    ${LIBRARY_SOURCE_PATH}/clone_input_output_stream.c
    ${LIBRARY_SOURCE_PATH}/cmdline.c
    ${LIBRARY_SOURCE_PATH}/concat_input_stream.c
    ${LIBRARY_SOURCE_PATH}/config_cmdline.c
    ${LIBRARY_SOURCE_PATH}/config_file_reader.c
    ${LIBRARY_SOURCE_PATH}/config_key.c
    ${LIBRARY_SOURCE_PATH}/config_logger.c
    ${LIBRARY_SOURCE_PATH}/config_settings.c
    ${LIBRARY_SOURCE_PATH}/config_struct.c
    ${LIBRARY_SOURCE_PATH}/counter_output_stream.c
    ${LIBRARY_SOURCE_PATH}/crypto.c
    ${LIBRARY_SOURCE_PATH}/crc32.c
    ${LIBRARY_SOURCE_PATH}/debug.c
    ${LIBRARY_SOURCE_PATH}/debug_bench.c
    ${LIBRARY_SOURCE_PATH}/debug_bfd.c
    ${LIBRARY_SOURCE_PATH}/debug_malloc.c
    ${LIBRARY_SOURCE_PATH}/debug_mmap.c
    ${LIBRARY_SOURCE_PATH}/debug_stacktrace.c
    ${LIBRARY_SOURCE_PATH}/digest_rawdata.c
    ${LIBRARY_SOURCE_PATH}/dns_udp.c
    ${LIBRARY_SOURCE_PATH}/dns_message_verify_rrsig.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer_dig.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer_json.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer_easyparse.c
    ${LIBRARY_SOURCE_PATH}/dns_resource_record.c
    ${LIBRARY_SOURCE_PATH}/dnscore.c
    ${LIBRARY_SOURCE_PATH}/dnscore_extension.c
    ${LIBRARY_SOURCE_PATH}/dnsformat.c
    ${LIBRARY_SOURCE_PATH}/dnskey.c
    ${LIBRARY_SOURCE_PATH}/dnskey_keyring.c
    ${LIBRARY_SOURCE_PATH}/dnskey_eddsa.c
    ${LIBRARY_SOURCE_PATH}/dnskey_signature.c
    ${LIBRARY_SOURCE_PATH}/dnsname.c
    ${LIBRARY_SOURCE_PATH}/empty_input_stream.c
    ${LIBRARY_SOURCE_PATH}/error_state.c
    ${LIBRARY_SOURCE_PATH}/fdtools.c
    ${LIBRARY_SOURCE_PATH}/file_input_stream.c
    ${LIBRARY_SOURCE_PATH}/file_mtime_set.c
    ${LIBRARY_SOURCE_PATH}/file_output_stream.c
    ${LIBRARY_SOURCE_PATH}/file_pool.c
    ${LIBRARY_SOURCE_PATH}/filesystem_file.c
    ${LIBRARY_SOURCE_PATH}/format.c
    ${LIBRARY_SOURCE_PATH}/hash.c
    ${LIBRARY_SOURCE_PATH}/hash_table_values.c
    ${LIBRARY_SOURCE_PATH}/host_address.c
    #${LIBRARY_SOURCE_PATH}/hsdllist.c
    ${LIBRARY_SOURCE_PATH}/http_chunk_output_stream.c
    ${LIBRARY_SOURCE_PATH}/identity.c
    ${LIBRARY_SOURCE_PATH}/initialise_state.c
    ${LIBRARY_SOURCE_PATH}/input_stream.c
    #${LIBRARY_SOURCE_PATH}/ipc.c
    ${LIBRARY_SOURCE_PATH}/json.c
    ${LIBRARY_SOURCE_PATH}/limited_input_stream.c
    ${LIBRARY_SOURCE_PATH}/limiter.c
    ${LIBRARY_SOURCE_PATH}/list_dl.c
    ${LIBRARY_SOURCE_PATH}/list_dl_nodata.c
    ${LIBRARY_SOURCE_PATH}/list_sl.c
    ${LIBRARY_SOURCE_PATH}/list_sl_debug.c
    ${LIBRARY_SOURCE_PATH}/logger_output_stream.c
    ${LIBRARY_SOURCE_PATH}/logger.c
    ${LIBRARY_SOURCE_PATH}/logger_channel_file.c
    ${LIBRARY_SOURCE_PATH}/logger_channel_stream.c
    ${LIBRARY_SOURCE_PATH}/logger_channel_syslog.c
    ${LIBRARY_SOURCE_PATH}/logger_handle.c
    ${LIBRARY_SOURCE_PATH}/mapped_file.c
    ${LIBRARY_SOURCE_PATH}/dns_message.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer.c
    ${LIBRARY_SOURCE_PATH}/dns_message_update.c
    ${LIBRARY_SOURCE_PATH}/mt_output_stream.c
    ${LIBRARY_SOURCE_PATH}/mutex.c
    ${LIBRARY_SOURCE_PATH}/mutex_contention_monitor.c
    ${LIBRARY_SOURCE_PATH}/mutex_debug.c
    ${LIBRARY_SOURCE_PATH}/mutex_futex.c
    ${LIBRARY_SOURCE_PATH}/mutex_group.c
    ${LIBRARY_SOURCE_PATH}/mutex_mutex.c
    ${LIBRARY_SOURCE_PATH}/mutex_shared_group.c
    ${LIBRARY_SOURCE_PATH}/network.c
    #${LIBRARY_SOURCE_PATH}/name.c
    ${LIBRARY_SOURCE_PATH}/nsec3_hash.c
    ${LIBRARY_SOURCE_PATH}/output_stream.c
    ${LIBRARY_SOURCE_PATH}/pace.c
    ${LIBRARY_SOURCE_PATH}/dns_packet_reader.c
    ${LIBRARY_SOURCE_PATH}/dns_packet_writer.c
    ${LIBRARY_SOURCE_PATH}/parser.c
    ${LIBRARY_SOURCE_PATH}/parsing.c
    ${LIBRARY_SOURCE_PATH}/pcg_basic.c
    ${LIBRARY_SOURCE_PATH}/permut.c
    ${LIBRARY_SOURCE_PATH}/process.c
    ${LIBRARY_SOURCE_PATH}/pid.c
    ${LIBRARY_SOURCE_PATH}/pipe_stream.c
    ${LIBRARY_SOURCE_PATH}/pool.c
    ${LIBRARY_SOURCE_PATH}/ptr_treeset.c
    ${LIBRARY_SOURCE_PATH}/ptr_treeset_debug.c
    ${LIBRARY_SOURCE_PATH}/ptr_treemap.c
    ${LIBRARY_SOURCE_PATH}/ptr_treemap_debug.c
    ${LIBRARY_SOURCE_PATH}/ptr_vector.c
    ${LIBRARY_SOURCE_PATH}/pushback_input_stream.c
    ${LIBRARY_SOURCE_PATH}/queue_sl.c
    ${LIBRARY_SOURCE_PATH}/random.c
    ${LIBRARY_SOURCE_PATH}/rest_client.c
    ${LIBRARY_SOURCE_PATH}/rest_server.c
    ${LIBRARY_SOURCE_PATH}/rewind_input_stream.c
    ${LIBRARY_SOURCE_PATH}/rfc.c
    ${LIBRARY_SOURCE_PATH}/rndc.c
    ${LIBRARY_SOURCE_PATH}/serial.c
    ${LIBRARY_SOURCE_PATH}/server_setup.c
    ${LIBRARY_SOURCE_PATH}/service.c
    ${LIBRARY_SOURCE_PATH}/shared_heap.c
    ${LIBRARY_SOURCE_PATH}/shared_circular_buffer.c
    ${LIBRARY_SOURCE_PATH}/shared_heap_bytearray_output_stream.c
    ${LIBRARY_SOURCE_PATH}/signals.c
    ${LIBRARY_SOURCE_PATH}/simple_http_server.c
    ${LIBRARY_SOURCE_PATH}/socket_server.c
    ${LIBRARY_SOURCE_PATH}/ssl_input_output_stream.c
    ${LIBRARY_SOURCE_PATH}/string_set.c
    ${LIBRARY_SOURCE_PATH}/sys_error.c
    ${LIBRARY_SOURCE_PATH}/sys_get_cpu_count.c
    ${LIBRARY_SOURCE_PATH}/tcp_io_stream.c
    ${LIBRARY_SOURCE_PATH}/tcp_manager2.c
    ${LIBRARY_SOURCE_PATH}/tcp_manager_channel_ssl_context.c
    ${LIBRARY_SOURCE_PATH}/thread_pool.c
    ${LIBRARY_SOURCE_PATH}/thread.c
    ${LIBRARY_SOURCE_PATH}/thread_setaffinity_macos.c
    ${LIBRARY_SOURCE_PATH}/thread_tag.c
    ${LIBRARY_SOURCE_PATH}/threaded_qsl_cw.c
    ${LIBRARY_SOURCE_PATH}/threaded_dll_cw.c
    ${LIBRARY_SOURCE_PATH}/threaded_nbrb.c
    ${LIBRARY_SOURCE_PATH}/threaded_queue_slg.c
    ${LIBRARY_SOURCE_PATH}/threaded_ringbuffer_cw.c
    ${LIBRARY_SOURCE_PATH}/timeformat.c
    ${LIBRARY_SOURCE_PATH}/timems.c
    ${LIBRARY_SOURCE_PATH}/tools.c
    ${LIBRARY_SOURCE_PATH}/typebitmap.c
    ${LIBRARY_SOURCE_PATH}/u32_treeset.c
    ${LIBRARY_SOURCE_PATH}/u64_treeset.c
    ${LIBRARY_SOURCE_PATH}/u64_treeset_debug.c
    ${LIBRARY_SOURCE_PATH}/u32_treemap.c
    ${LIBRARY_SOURCE_PATH}/u64_treemap.c
    ${LIBRARY_SOURCE_PATH}/uri.c
    ${LIBRARY_SOURCE_PATH}/utf8.c
    ${LIBRARY_SOURCE_PATH}/xfr_input_stream.c
    ${LIBRARY_SOURCE_PATH}/zalloc.c
    ${LIBRARY_SOURCE_PATH}/zone_reader_axfr.c
    ${LIBRARY_SOURCE_PATH}/zone_reader_text.c
)

if(NOT WIN32)
    if(OPENSSL_VERSION_MAJOR LESS 3)
        message("using libssl < 3.0 API")
        set(LIBRARY_SOURCES ${LIBRARY_SOURCES}
            #${LIBRARY_SOURCE_PATH}/dnskey_dsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_ecdsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_rsa.c
            ${LIBRARY_SOURCE_PATH}/digest_sha1.c
            ${LIBRARY_SOURCE_PATH}/digest_sha256.c
            ${LIBRARY_SOURCE_PATH}/digest_sha384.c
            ${LIBRARY_SOURCE_PATH}/digest_sha512.c
            ${LIBRARY_SOURCE_PATH}/hmac_openssl.c)
    else()
        message("using libssl >= 3.0 API")
        set(LIBRARY_SOURCES ${LIBRARY_SOURCES}
            ${LIBRARY_SOURCE_PATH}/dnskey_evp.c
            #${LIBRARY_SOURCE_PATH}/dnskey_evp_dsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_evp_ecdsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_evp_rsa.c
            ${LIBRARY_SOURCE_PATH}/digest_evp.c
            ${LIBRARY_SOURCE_PATH}/hmac_evp.c)
    endif()
    set(LIBRARY_SOURCES ${LIBRARY_SOURCES} ${LIBRARY_SOURCE_PATH}/digest_md5_internal.c)
else()
    message("using libssl >= 3.0 API")
    set(LIBRARY_SOURCES ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/dnskey_evp.c
        #${LIBRARY_SOURCE_PATH}/dnskey_evp_dsa.c
        ${LIBRARY_SOURCE_PATH}/dnskey_evp_ecdsa.c
        ${LIBRARY_SOURCE_PATH}/dnskey_evp_rsa.c
        ${LIBRARY_SOURCE_PATH}/digest_evp.c
        ${LIBRARY_SOURCE_PATH}/hmac_evp.c)
endif()

set(LIBRARY_HEADERS
    ${LIBRARY_HEADER_PATH}/acl.h
    ${LIBRARY_HEADER_PATH}/acl_config.h
    ${LIBRARY_HEADER_PATH}/alarm.h
    #${LIBRARY_HEADER_PATH}/allocator.h
    ${LIBRARY_HEADER_PATH}/async.h
    ${LIBRARY_HEADER_PATH}/avl.c.inc
    ${LIBRARY_HEADER_PATH}/avl.h.inc
    ${LIBRARY_HEADER_PATH}/base16.h
    ${LIBRARY_HEADER_PATH}/base32.h
    ${LIBRARY_HEADER_PATH}/base32hex.h
    ${LIBRARY_HEADER_PATH}/base64.h
    ${LIBRARY_HEADER_PATH}/basic_priority_queue.h
    ${LIBRARY_HEADER_PATH}/buffer_input_stream.h
    ${LIBRARY_HEADER_PATH}/buffer_output_stream.h
    ${LIBRARY_HEADER_PATH}/buffered_file.h
    ${LIBRARY_HEADER_PATH}/bytearray_input_stream.h
    ${LIBRARY_HEADER_PATH}/bytearray_output_stream.h
    ${LIBRARY_HEADER_PATH}/bytezarray_output_stream.h
    ${LIBRARY_HEADER_PATH}/cache.h
    ${LIBRARY_HEADER_PATH}/checked_output_stream.h
    ${LIBRARY_HEADER_PATH}/circular_file.h
    ${LIBRARY_HEADER_PATH}/clone_input_output_stream.h
    ${LIBRARY_HEADER_PATH}/cmdline.h
