=== debian/changelog ===
yadifa (3.0.2-3) unstable; urgency=medium

  * Expand libatomic patch

 -- Markus Schade <markus.schade@gmail.com>  Tue, 11 Mar 2025 19:11:29 +0100

yadifa (3.0.2-2) unstable; urgency=medium

  * Add libatomic-processor patch to fix armel build

 -- Markus Schade <markus.schade@gmail.com>  Tue, 11 Mar 2025 18:27:37 +0100

yadifa (3.0.2-1) unstable; urgency=medium

  * New upstream version 3.0.2

 -- Markus Schade <markus.schade@gmail.com>  Tue, 11 Mar 2025 15:35:22 +0100
