=== debian/watch ===
version=4
opts="mode=git, pgpmode=gittag, uversionmangle=s/v//" \
https://github.com/yadifa/yadifa.git \
refs/tags/([v\d\.]+)
